﻿Imports MvcMusicStoreVB.Models
Imports MvcMusicStoreVB.ViewModels

Namespace Controllers
    Public Class ShoppingCartController
        Inherits System.Web.Mvc.Controller

        Private storeDB As MusicStoreEntities = New MusicStoreEntities

        '
        ' GET: /ShoppingCart

        Function Index() As ActionResult
            Dim cart = ShoppingCart.GetCart(HttpContext)

            Dim viewModel = New ShoppingCartViewModel With {
                .CartItems = cart.GetCartItems,
                .CartTotal = cart.GetTotal
            }

            Return View(viewModel)
        End Function

        '
        ' GET: /ShoppingCart/AddToCart/5

        Function AddToCart(ByVal id As Integer) As ActionResult
            Dim addedAlbum = storeDB.Albums.Single(Function(album) album.AlbumId = id)

            Dim cart = ShoppingCart.GetCart(HttpContext)

            cart.AddToCart(addedAlbum)

            Return RedirectToAction("Index")
        End Function

        '
        ' AJAX: /ShoppingCart/RemoveFromCart/5

        <HttpPost()>
        Public Function RemoveFromCart(ByVal id As Integer) As ActionResult
            Dim cart = ShoppingCart.GetCart(HttpContext)

            Dim albumName = storeDB.Carts.Single(Function(item) item.RecordId = id).Album.Title

            Dim itemCount = cart.RemoveFromCart(id)

            Dim results = New ShoppingCartRemoveViewModel With {
                .Message = Server.HtmlEncode(albumName) &
                    " has been removed from your shopping cart.",
                .CartTotal = cart.GetTotal,
                .CartCount = cart.GetCount,
                .ItemCount = itemCount,
                .DeleteId = id
            }

            Return Json(results)
        End Function

        '
        ' GET: /ShoppingCart/CartSummary

        <ChildActionOnly()>
        Public Function CartSummary() As ActionResult
            Dim cart = ShoppingCart.GetCart(HttpContext)

            ViewBag.CartCount = cart.GetCount

            Return PartialView("CartSummary")
        End Function
    End Class
End Namespace